package ru.ldeloff.servermonitorbot.init;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;
import ru.ldeloff.servermonitorbot.config.UserConfig;
import ru.ldeloff.servermonitorbot.mapper.UserMapper;
import ru.ldeloff.servermonitorbot.model.User;
import ru.ldeloff.servermonitorbot.model.dto.InitUserDto;
import ru.ldeloff.servermonitorbot.service.user.UserService;

import java.util.List;

@Component
public class AddUsers implements ApplicationRunner {
    final List<InitUserDto> initUsers;
    final UserService userService;
    final UserMapper userMapper;

    @Autowired
    public AddUsers(UserConfig userConfig, UserService userService, UserMapper userMapper) {
        this.initUsers = userConfig.getUsers();
        this.userService = userService;
        this.userMapper = userMapper;
    }

    @Override
    public void run(ApplicationArguments args) throws Exception {
        initUsers.forEach(initUserDto -> {
            User user = userService.saveOrUpdateUser(userMapper.dtoToUser(initUserDto));
        });
    }
}
